package com.inca.npbusi.allotqtydef;

import com.inca.np.auth.ClientUserManager;
import com.inca.np.auth.Userruninfo;
import com.inca.np.communicate.ClientRequest;
import com.inca.np.communicate.DataCommand;
import com.inca.np.communicate.ParamCommand;
import com.inca.np.communicate.ServerResponse;
import com.inca.np.communicate.StringCommand;
import com.inca.np.gui.control.CFrame;
import com.inca.np.gui.control.DBTableModel;
import com.inca.np.gui.mde.CDetailModel;
import com.inca.np.gui.mde.CMasterModel;
import com.inca.np.util.SendHelper;
import com.inca.npx.mde.CMdeModelAp;
import com.inca.pubsrv.NpbusiDBHelper;

public class Allotqty_def_mde extends CMdeModelAp {
   public Allotqty_def_mde(CFrame var1, String var2) {
      super(var1, var2);
   }

   protected CMasterModel createMastermodel() {
      return new Allotqty_def_master(this.frame, this);
   }

   protected CDetailModel createDetailmodel() {
      return new Allotqty_def_detail(this.frame, this);
   }

   public String getMasterRelatecolname() {
      return "defdocid";
   }

   public String getDetailRelatecolname() {
      return "defdocid";
   }

   public String getSaveCommandString() {
      return "Allotqty_def_mde.保存销售配额定义";
   }

   protected int on_actionPerformed(String var1) {
      if (var1.equals("确定")) {
         Allotqty_def_mde var2 = this;
         if (this.getMasterModel().getModifiedDbmodel().getRowCount() > 0) {
            this.infoMessage("提示", "有尚未保存的单据，请先作保存！");
         } else {
            int[] var3;
            if ((var3 = this.mastermodel.getTable().getSelectedRows()).length <= 0) {
               this.infoMessage("提示", "请选择单据操作，可以多选！");
            } else {
               ClientRequest var4 = new ClientRequest();
               StringCommand var5 = null;
               var5 = new StringCommand("配额定义:确定");
               ParamCommand var6 = new ParamCommand();
               String var7 = null;

               for(int var8 = 0; var8 < var3.length; ++var8) {
                  var7 = var2.mastermodel.getItemValue(var3[var8], "defdocid");
                  String var9 = var2.mastermodel.getItemValue(var3[var8], "usestatus");
                  if (!"0".equals(var9)) {
                     var2.infoMessage("提示", "第" + (var3[var8] + 1) + "行单据配额定义不是临时状态，不能确定！");
                     return super.on_actionPerformed(var1);
                  }

                  var6.addParam("defdocid" + var8, var7);
               }

               var4.addCommand(var5);
               var4.addCommand(var6);

               try {
                  StringCommand var11 = (StringCommand)SendHelper.sendRequest(var4).commandAt(0);
                  Userruninfo var13 = ClientUserManager.getCurrentUser();
                  if (var11.getString().startsWith("+OK")) {
                     var2.infoMessage("提示", "确定操作完成!");

                     for(int var12 = 0; var12 < var3.length; ++var12) {
                        var2.mastermodel.setItemValue(var3[var12], "usestatus", "1");
                        var2.mastermodel.setItemValue(var3[var12], "confirmmanid", var13.getUserid());
                        var2.mastermodel.setItemValue(var3[var12], "confirmman", var13.getUsername());
                        var2.mastermodel.setItemValue(var3[var12], "confirmdate", NpbusiDBHelper.getSysdate());
                        var2.mastermodel.setdbStatus(var3[var12], 0);
                        var2.mastermodel.tableChanged();
                     }
                  } else {
                     var2.infoMessage("提示", "确定操作失败:" + var11.getString());
                  }
               } catch (Exception var10) {
                  var2.infoMessage("提示", "确定操作出错:" + var10.getMessage());
                  var10.printStackTrace();
               }
            }
         }
      } else if (var1.equals("中止")) {
         this.b();
      } else if (var1.equals("重复执行")) {
         this.a();
      }

      return super.on_actionPerformed(var1);
   }

   private void a() {
      if (this.getMasterModel().getModifiedDbmodel().getRowCount() > 0) {
         this.infoMessage("提示", "有尚未保存的单据，请先作保存！");
      } else {
         int[] var1;
         if ((var1 = this.mastermodel.getTable().getSelectedRows()).length <= 0) {
            this.infoMessage("提示", "请选择单据操作，只能选择一条总单！");
         } else if (var1.length > 1) {
            this.infoMessage("提示", "请选择单据操作，只能选择一条总单！");
         } else {
            int var8 = this.mastermodel.getRow();
            String var2 = this.mastermodel.getItemValue(var8, "defdocid");
            ClientRequest var3 = new ClientRequest();
            StringCommand var4 = null;
            var4 = new StringCommand("配额定义:重复执行单据");
            ParamCommand var5 = new ParamCommand();
            StringCommand var6 = null;
            String var9 = this.mastermodel.getItemValue(var8, "usestatus");
            if ("0".equals(var9)) {
               this.infoMessage("提示", "所选配额定义单据为\"临时\"状态，可直接修改，不需要操作\"重复执行\"！");
            } else {
               var5.addParam("defdocid", var2);
               var3.addCommand(var4);
               var3.addCommand(var5);

               try {
                  ServerResponse var14;
                  if (!(var6 = (StringCommand)(var14 = SendHelper.sendRequest(var3)).commandAt(0)).getString().startsWith("+OK")) {
                     this.infoMessage("提示", "重复执行单据失败:" + var6.getString());
                  } else {
                     this.infoMessage("提示", "重复执行完成！");
                     DBTableModel var10 = ((DataCommand)var14.commandAt(1)).getDbmodel();
                     Userruninfo var11 = ClientUserManager.getCurrentUser();
                     this.mastermodel.getDBtableModel().appendRow();
                     int var13 = this.mastermodel.getRow();
                     int var15 = this.mastermodel.getRowCount() - 1;
                     this.mastermodel.setItemValue(var15, "goodsid", this.mastermodel.getItemValue(var13, "goodsid"));
                     this.mastermodel.setItemValue(var15, "opcode", this.mastermodel.getItemValue(var13, "opcode"));
                     this.mastermodel.setItemValue(var15, "goodsname", this.mastermodel.getItemValue(var13, "goodsname"));
                     this.mastermodel.setItemValue(var15, "goodstype", this.mastermodel.getItemValue(var13, "goodstype"));
                     this.mastermodel.setItemValue(var15, "goodsunit", this.mastermodel.getItemValue(var13, "goodsunit"));
                     this.mastermodel.setItemValue(var15, "prodarea", this.mastermodel.getItemValue(var13, "prodarea"));
                     this.mastermodel.setItemValue(var15, "factoryname", this.mastermodel.getItemValue(var13, "factoryname"));
                     this.mastermodel.setItemValue(var15, "usestatus", "0");
                     this.mastermodel.setItemValue(var15, "inputmanid", var11.getUserid());
                     this.mastermodel.setItemValue(var15, "inputman", var11.getUsername());
                     this.mastermodel.setItemValue(var15, "credate", NpbusiDBHelper.getSysdate());
                     this.mastermodel.getTable().setRowSelectionInterval(var15, var15);

                     int var12;
                     for(var12 = this.detailmodel.getRowCount() - 1; var12 >= 0; --var12) {
                        this.detailmodel.getDBtableModel().removeRow(var12);
                     }

                     for(var12 = 0; var12 < var10.getRowCount(); ++var12) {
                        this.detailmodel.getDBtableModel().appendRow();
                        var13 = this.detailmodel.getRowCount() - 1;
                        this.detailmodel.setItemValue(var13, "customid", var10.getItemValue(var12, "customid"));
                        this.detailmodel.setItemValue(var13, "customname", var10.getItemValue(var12, "customname"));
                        this.detailmodel.setItemValue(var13, "customopcode", var10.getItemValue(var12, "customopcode"));
                        this.detailmodel.setItemValue(var13, "allotqty", var10.getItemValue(var12, "allotqty"));
                     }

                     this.mastermodel.tableChanged();
                     this.detailmodel.tableChanged();
                  }
               } catch (Exception var7) {
                  this.infoMessage("提示", "重复执行单据出错:" + var7.getMessage());
                  var7.printStackTrace();
               }
            }
         }
      }
   }

   private void b() {
      if (this.getMasterModel().getModifiedDbmodel().getRowCount() > 0) {
         this.infoMessage("提示", "有尚未保存的单据，请先作保存！");
      } else {
         int[] var1;
         if ((var1 = this.mastermodel.getTable().getSelectedRows()).length <= 0) {
            this.infoMessage("提示", "请选择单据操作，可以多选！");
         } else {
            ClientRequest var2 = new ClientRequest();
            StringCommand var3 = null;
            var3 = new StringCommand("配额定义:中止");
            ParamCommand var4 = new ParamCommand();
            StringCommand var5 = null;

            int var9;
            for(var9 = 0; var9 < var1.length; ++var9) {
               String var6 = this.mastermodel.getItemValue(var1[var9], "defdocid");
               String var7 = this.mastermodel.getItemValue(var1[var9], "usestatus");
               if (!"1".equals(var7)) {
                  this.infoMessage("提示", "第" + (var1[var9] + 1) + "行单据配额定义不是确定状态，不用中止，\n临时状态的单据可以直接删除！");
                  return;
               }

               var4.addParam("defdocid" + var9, var6);
            }

            var2.addCommand(var3);
            var2.addCommand(var4);

            try {
               if (!(var5 = (StringCommand)SendHelper.sendRequest(var2).commandAt(0)).getString().startsWith("+OK")) {
                  this.infoMessage("提示", "中止操作失败:" + var5.getString());
               } else {
                  this.infoMessage("提示", "中止操作完成!");

                  for(var9 = 0; var9 < var1.length; ++var9) {
                     this.mastermodel.setItemValue(var1[var9], "usestatus", "2");
                     this.mastermodel.setdbStatus(var1[var9], 0);
                     this.mastermodel.tableChanged();
                  }

               }
            } catch (Exception var8) {
               this.infoMessage("提示", "中止操作出错:" + var8.getMessage());
               var8.printStackTrace();
            }
         }
      }
   }
}
